diff --git a/cmd/Kconfig b/cmd/Kconfig
index 6403bc45a5..e5d0e7f7c3 100644
--- a/cmd/Kconfig
+++ b/cmd/Kconfig
@@ -1673,6 +1673,12 @@ config CMD_DATE
 	  Enable the 'date' command for getting/setting the time/date in RTC
 	  devices.
 
+config CMD_RTC
+	bool "rtc"
+	depends on DM_RTC
+	help
+	  Enable the 'rtc' command for low-level access to RTC devices.
+
 config CMD_TIME
 	bool "time"
 	help
diff --git a/cmd/Makefile b/cmd/Makefile
index f1dd513a4b..871b07f7b2 100644
--- a/cmd/Makefile
+++ b/cmd/Makefile
@@ -119,6 +119,7 @@ obj-$(CONFIG_CMD_REISER) += reiser.o
 obj-$(CONFIG_CMD_REMOTEPROC) += remoteproc.o
 obj-$(CONFIG_CMD_RNG) += rng.o
 obj-$(CONFIG_CMD_ROCKUSB) += rockusb.o
+obj-$(CONFIG_CMD_RTC) += rtc.o
 obj-$(CONFIG_SANDBOX) += host.o
 obj-$(CONFIG_CMD_SATA) += sata.o
 obj-$(CONFIG_CMD_NVME) += nvme.o
diff --git a/cmd/rtc.c b/cmd/rtc.c
new file mode 100644
index 0000000000..d48c0333fa
--- /dev/null
+++ b/cmd/rtc.c
@@ -0,0 +1,153 @@
+// SPDX-License-Identifier: GPL-2.0+
+
+#include <common.h>
+#include <command.h>
+#include <dm.h>
+#include <hexdump.h>
+#include <i2c.h>
+#include <rtc.h>
+
+#define MAX_RTC_BYTES 32
+
+static int do_rtc_read(struct udevice *dev, int argc, char * const argv[], int mem)
+{
+	u8 buf[MAX_RTC_BYTES];
+	int reg, len, ret;
+	u8 *addr;
+
+	if (argc != 2 + mem)
+		return CMD_RET_USAGE;
+
+	if (mem) {
+		addr = (void*)simple_strtoul(argv[0], NULL, 16);
+		argv++;
+		argv--;
+	} else {
+		addr = buf;
+	}
+	reg = simple_strtoul(argv[0], NULL, 0);
+	len = simple_strtoul(argv[1], NULL, 0);
+
+	if (!mem && len > sizeof(buf)) {
+		printf("can read at most %d registers at a time\n", MAX_RTC_BYTES);
+		return CMD_RET_FAILURE;
+	}
+	ret = rtc_read8_array(dev, reg, buf, len);
+	if (ret) {
+		printf("rtc_read8_array() failed: %d\n", ret);
+		return CMD_RET_FAILURE;
+	}
+	if (!mem) {
+		while (len--)
+			printf("%d: 0x%02x\n", reg++, *addr++);
+	}
+	return CMD_RET_SUCCESS;
+}
+
+static int do_rtc_write(struct udevice *dev, int argc, char * const argv[], int mem)
+{
+	u8 buf[MAX_RTC_BYTES];
+	u8 *addr;
+	int reg, len, ret;
+
+	if (argc != 2 + mem)
+		return CMD_RET_USAGE;
+
+	if (mem) {
+		addr = (void*)simple_strtoul(argv[0], NULL, 16);
+		argv++;
+		argv--;
+	} else {
+		addr = buf;
+	}
+
+	reg = simple_strtoul(argv[0], NULL, 0);
+	if (mem) {
+		len = simple_strtoul(argv[1], NULL, 0);
+	} else {
+		/* Convert hexstring, bail out if too long. */
+		const char *s = argv[1];
+
+		len = strlen(s);
+		if (len > 2*MAX_RTC_BYTES) {
+			printf("hex string too long, can write at most %d bytes\n", MAX_RTC_BYTES);
+			return CMD_RET_FAILURE;
+		}
+		len /= 2;
+		if (hex2bin(addr, s, len)) {
+			printf("invalid hex string\n");
+			return CMD_RET_FAILURE;
+		}
+	}
+
+	ret = rtc_write8_array(dev, reg, buf, len);
+	if (ret) {
+		printf("rtc_write8_array() failed: %d\n", ret);
+		return CMD_RET_FAILURE;
+	}
+	return CMD_RET_SUCCESS;
+}
+
+int do_rtc(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	static int curr_rtc = 0;
+	struct udevice *dev;
+	int ret, idx;
+
+	if (argc < 2)
+		return CMD_RET_USAGE;
+
+	argc--;
+	argv++;
+
+	if (!strcmp(argv[0], "list")) {
+		struct uclass *uc;
+		idx = 0;
+
+		uclass_id_foreach_dev(UCLASS_RTC, dev, uc) {
+			printf("RTC #%d - %s\n", idx++, dev->name);
+		}
+		if (!idx) {
+			printf("*** no RTC devices available ***\n");
+			return CMD_RET_FAILURE;
+		}
+		return CMD_RET_SUCCESS;
+	}
+
+	idx = curr_rtc;
+	if (!strcmp(argv[0], "dev") && argc >= 2)
+		idx = simple_strtoul(argv[1], NULL, 10);
+
+	ret = uclass_get_device(UCLASS_RTC, idx, &dev);
+	if (ret) {
+		printf("Cannot find RTC #%d: err=%d\n", idx, ret);
+		return CMD_RET_FAILURE;
+	}
+
+	if (!strcmp(argv[0], "dev")) {
+		/* Show the existing or newly selected RTC */
+		if (argc >= 2)
+			curr_rtc = idx;
+		printf("RTC #%d - %s\n", idx, dev->name);
+		return CMD_RET_SUCCESS;
+	}
+
+	if (!strcmp(argv[0], "read") || !strcmp(argv[0], "readm"))
+		return do_rtc_read(dev, argc - 1, argv + 1, !strcmp(argv[0], "readm"));
+
+	if (!strcmp(argv[0], "write") || !strcmp(argv[0], "writem"))
+		return do_rtc_write(dev, argc - 1, argv + 1, !strcmp(argv[0], "writem"));
+
+	return CMD_RET_USAGE;
+}
+
+U_BOOT_CMD(
+	rtc,	5,	0,	do_rtc,
+	"RTC subsystem",
+	"list                        - show available rtc devices\n"
+	"rtc dev [n]                     - show or set current rtc device\n"
+	"rtc read <reg> <count>          - read and display 8-bit registers starting at <reg>\n"
+	"rtc readm <addr> <reg> <count>  - read 8-bit registers starting at <reg> to memory\n"
+	"rtc write <reg> <hexstring>     - write 8-bit registers starting at <reg>\n"
+	"rtc writem <addr> <reg> <count> - write memory to 8-bit registers starting at <reg>\n"
+);